import { LogicFlow } from '@logicflow/core';
import { BaseSchemaDSL, ComponentDSL } from '@lowcode-set-up-platform/dsl';
import GraphData = LogicFlow.GraphData;
import NodeConfig = LogicFlow.NodeConfig;
export interface INodeInfo {
    schema?: ComponentDSL;
    Comp: any;
    componentInfo?: any;
    componentChildren?: any;
}
interface ExecuteContext extends Record<any, any> {
    pageInstance: any;
    schema?: ComponentDSL;
    args?: any;
}
export declare class Runner {
    nodes: NodeConfig[];
    private snapshootWindow;
    registerWindow(_window: Window | any): void;
    constructor();
    registerNode(nodes: NodeConfig[]): void;
    /**
     * 执行
     */
    execute(graphData: GraphData, context?: ExecuteContext): Promise<void>;
    getRenderSchema(): BaseSchemaDSL;
    /**
     * 执行声明周期流程编排逻辑
     * @param lifeCycle
     * @param schema
     * @param context
     * @param args
     */
    executeLifeCycle(lifeCycle: string, schema: ComponentDSL, context: any, args: any): Promise<void>;
    /**
     * 执行方法的编排逻辑
     * @param path
     * @param schema
     * @param context
     * @param args
     */
    executeFunction(path: string, schema: INodeInfo, context: any, args: any): Promise<void>;
}
export {};
